


#ifndef EagleTimer_HPP
#define EagleTimer_HPP


class EagleTimer : public EagleEventSource {
private :
   int id;// unique id
protected :
   double spt;// seconds per tick
   unsigned long long previous_ticks;
   unsigned long long current_ticks;
   
   static int NextId() {
      static int i = 0;
      return i++;
   }
   
   virtual void RefreshTimer()=0;
   
public :
   
   EagleTimer() : id(NextId()) , spt(0.0) , previous_ticks(0UL) , current_ticks(0UL) {}
   virtual ~EagleTimer() {}

   virtual bool Create(double seconds_per_tick)=0;
   virtual void Destroy()=0;
   virtual void Start()=0;
   virtual void Stop()=0;
   virtual void WaitForTick()=0;
   
   int ID() {return id;}
   double SPT() {return spt;}
   unsigned long long Count() {return current_ticks;}
   virtual void* Source()=0;

   // time passed - since when? last check? since last take time?

   // time passed since the last TakeAllTime was called
   unsigned long long TicksPassed();
   double TimePassed();
   double TakeAllTime();
};


#endif // EagleTimer_HPP
